Core - Bug # 44645

Status: Resolved Priority: Should have

Author: Marcel Burkhalter Category: File Abstraction Layer (FAL)
Created: 2013-01-18 Assigned To:

Updated: 2015-02-14 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity: medium

Is Regression: No

Sprint Focus: On Location Sprint

Subject: Preview images don't get a new filename after overwriting with updated file

Description

Steps to reproduce:

- Upload a file in the filelist

- Check filename of preview image (e.g.: preview_102455_4635_924f2e40ad.jpg)
- Overwrite with a file with the same filename but different file content

- Check preview filename again --> it stays the same

--> We've seen caching issues with IE9 because of this

As a workaround we added the following config in the .htaccess file:

<FilesMatch ""preview_.*\.(joe?g|png|gif)$">
FileETag none
<ifModule mod_headers.c>
Header unset ETag
Header set Cache-Control "max-age=0, no-cache, no-store, must-revalidate"
Header set Pragma "no-cache"
Header set Expires "Wed, 11 Jan 1984 05:00:00 GMT"
</ifModule>
</FilesMatch>

This worked for the filelist: we now see the correct preview image directly after overwriting without manual browser reload or browser
cache clearing.

BUT: In the list or page module we still see the old preview image until the IE9 tab has been reloaded (without the .htaccess rule we
had to clear the browser cache to see the updated preview image). Of course this all works flawlessly with FF :)

Related issues:

related to Core - Bug # 44073: Checksum needs to be updated after file proces... Resolved 2012-12-17
related to Core - Task # 44550: Preview image and database entry not deleted ... Closed 2013-01-15
related to Core - Bug # 56539: Update/Change file-hash when file is replaced ... Closed 2014-03-04
related to Core - Bug # 44105: Image size does not get updated Closed 2012-12-19

Associated revisions

Revision 5b9e6b81 - 2015-02-14 11:22 - Ruud Silvrants

[BUFGIX] Add modification time to processedfile checksum

Added modification time to processed file checksum so the filename of
the processed files changes when the original is replaced.
Resolves: #44645

Releases: master, 6.2

Change-Id: I12bf445ee2a75a9a69b3d8e9603ae5035028a195
Reviewed-on: http://review.typo3.0rg/36530

Reviewed-by: Frans Saris <franssaris@gmail.com>

Tested-by: Frans Saris <franssaris@gmail.com>

Reviewed-by: Philipp Thiele <philipp.thiele@phth.de>
Tested-by: Philipp Thiele <philipp.thiele@phth.de>
Tested-by: Andrea Herzog-Kienast <a.herzog@kienastdv.de>

Reviewed-by: Roman Schiirmann <roman.schuermann@wmdb.de>

Reviewed-by: Mathias Schreiber <mathias.schreiber@wmdb.de>

Tested-by: Mathias Schreiber <mathias.schreiber@wmdb.de>

Revision 251e5205 - 2015-02-14 20:03 - Ruud Silvrants

[BUFGIX] Add modification time to processedfile checksum

Added modification time to processed file checksum so the filename of

the processed files changes when the original is replaced.

Resolves: #44645

Releases: master, 6.2

Change-Id: I12bf445ee2a75a9a69b3d8e9603ae5035028a195
Reviewed-on: http://review.typo3.org/36898

Reviewed-by: Nicole Cordes <typo3@cordes.co>

Tested-by: Nicole Cordes <typo3@cordes.co>

History

#1 - 2013-02-04 11:26 - Andreas Wolf

- Status changed from New to Accepted

| suggest to include the timestamp or SHA1 hash in the name generation for the processed file. This should fix this and other issues around updating

processed files. I'll have to check again though what is currently used for filename generation - maybe there's also a bug in there.
#2 - 2013-02-04 11:26 - Andreas Wolf

- Project changed from File Abstraction Layer to Core

#3 - 2013-02-04 11:27 - Andreas Wolf

- Category set to File Abstraction Layer (FAL)

- Assigned To set to Andreas Wolf

- Target version set to 6.0.2

- TYPOS3 Version set to 6.0

#4 - 2013-02-08 13:10 - Andreas Wolf

This results from the filename not being adjusted in the patch for #44073. We'll have to tackle this.

#5 - 2013-03-22 10:45 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.

It is available at https://review.typo3.org/19170

#6 - 2013-03-22 11:26 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/19170

#7 - 2013-04-05 22:01 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.

It is available at https://review.typo3.0rg/19170

#8 - 2013-11-16 08:17 - Steffen Ritter

- Status changed from Under Review to Needs Feedback
- Assigned To deleted (Andreas Wolf)

- Is Regression set to No

the original patch set was abendonded

#9 - 2014-03-06 09:21 - Alexander Opitz
- Target version deleted (6.0.2)

Does the issue still exists? IMHO this was fixed in another issue.

#10 - 2014-05-10 15:18 - Sebastian Fischer

| can confirm that this problem still exists in current master
#11 - 2014-09-11 16:28 - Alexander Opitz

- Status changed from Needs Feedback to New

#12 - 2015-01-18 22:13 - Ingo Schmitt

- TYPOS3 Version changed from 6.0 to 6.2

- Sprint Focus set to On Location Sprint

#13 - 2015-01-30 10:37 - Andrea Herzog-Kienast
- Target version set to 7.1 (Cleanup)

#14 - 2015-01-30 11:17 - Andrea Herzog-Kienast

"BUT: In the list or page module we still see the old preview image until the IE9 tab has been reloaded (without the .htaccess rule we had to clear the
browser cache to see the updated preview image). Of course this all works flawlessly with FF :)"

This is not the case in 7.1 - behavoir is as expected.

#15 - 2015-01-30 16:05 - Ingo Schmitt
- Complexity set to medium

Solution could be to calculate the hash for the preview also by the filehash.

#16 - 2015-01-31 14:18 - Ingo Schmitt
- Status changed from New to In Progress

#17 - 2015-01-31 17:59 - Gerrit Code Review

- Status changed from In Progress to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36530

#18 - 2015-01-31 18:23 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/36530

#19 - 2015-01-31 21:36 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/36530

#20 - 2015-02-14 11:30 - Ruud Silvrants
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:5b9e6b818b0a3f0d518665529c883f452e2ce21b.

#21 - 2015-02-14 12:42 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36898

#22 - 2015-02-14 20:30 - Ruud Silvrants
- Status changed from Under Review to Resolved
Applied in changeset commit:251e52059e13c97ec1a294ee2bd258a9bd5532c4.
